#include <iostream>
#include <memory>
#include <string>

#include <grpcpp/ext/proto_server_reflection_plugin.h>
#include <grpcpp/grpcpp.h>
#include <grpcpp/health_check_service_interface.h>

#include "render.grpc.pb.h"

using grpc::Server;
using grpc::ServerBuilder;
using grpc::ServerContext;
using grpc::Status;
using nerfviewer::Render;
using nerfviewer::Transformation;
using nerfviewer::Image;

// Logic and data behind the server's behavior.
class RenderServiceImpl final : public Render::Service {
  Status Render(ServerContext* context, const Transformation* tf,
                  Image* image) override {

    // debug tf
    // for (int i = 0; i < tf->data_size(); i++) {
    //   std::cout << tf->data(i) << " ";
    // }
    // std::cout << std::endl;
    
    // for (int i = 0; i < tf->data_size(); i++) {
    //   std::cout << tf->data(i) << " ";
    // }
    image->set_data("");
    return Status::OK;
  }
};

void RunServer() {
  std::string server_address("0.0.0.0:50051");
  RenderServiceImpl service;

  grpc::EnableDefaultHealthCheckService(true);
  grpc::reflection::InitProtoReflectionServerBuilderPlugin();
  ServerBuilder builder;
  // Listen on the given address without any authentication mechanism.
  builder.AddListeningPort(server_address, grpc::InsecureServerCredentials());
  // Register "service" as the instance through which we'll communicate with
  // clients. In this case it corresponds to an *synchronous* service.
  builder.RegisterService(&service);
  // Finally assemble the server.
  std::unique_ptr<Server> server(builder.BuildAndStart());
  std::cout << "Server listening on " << server_address << std::endl;

  // Wait for the server to shutdown. Note that some other thread must be
  // responsible for shutting down the server for this call to ever return.
  server->Wait();
}

int main(int argc, char** argv) {
  RunServer();

  return 0;
}
